function Slider(){
}

Slider.dragging = false;

// eLXg{bNXp
Slider.prototype.ondrop = function(evt){
  this.onkeydown(evt);
}

// eLXg{bNXp
Slider.prototype.onkeydown = function(evt){
  // ]l̎擾
  var value = document.getElementById("slider_" + this.id + "_text").value;

  // ]l̑ޔ
  Slider.tmp_val = value;

  // XC_[ԍ̐ݒ
  Slider.current_id = this.id;

  // Vl擾Đɐi
  setTimeout( Slider.updateFromText, 0 );
}

// eLXg{bNX̒l𔽉f
Slider.updateFromText = function(){
  var id = Slider.current_id;
  var tmp_value = Slider.tmp_val;
  var new_value = document.getElementById("slider_" + id + "_text").value;

  // eLXg`FbN
  var num_str = Slider.str2num(new_value);
  if( num_str == "ERROR" ){
    // invalid string
    document.getElementById("slider_" + id + "_text").value = tmp_value;
    return;
  }
  if( num_str == "-" || num_str == "-." )num_str = "0";

  // r
  var min_val = Slider.min_vals[id];
  var max_val = Slider.max_vals[id];  
  var value = Number( num_str );
  if( value < min_val || value > max_val ){
    // out of range
    document.getElementById("slider_" + id + "_text").value = tmp_value;
    return false;
  }

  // sNZl̎擾
  Slider.value = value;
  var slider = document.getElementById( "slider_" + id );
  Slider.px = Math.floor( Slider.value * slider.clientWidth / ( Slider.max_vals[id] - Slider.min_vals[id] ) );

  // XC_[\XV
  Slider.updateBar();

  // V~[V
  Sim.simulate();

  // ȕ\XV
  Gui.updateSeatsDisplay();

  return;
}

/*
 ͂ꂽg߂āAƂėLȔpɕϊ
  ͉\:[-|\[]]?[0-9O-X]*[\.BD]?[0-9O-X]*
  ȕ܂ޏꍇA"ERROR"ԂB
*/
Slider.str2num = function( str ){
  var str2 = "";
  var phase = 0;
  var fixSign = function( c ){
    switch( c ){
      case "-":
      case "|":
      case "\":
      case "[":
      case "":
      case "]":
        return "-";
      default:
        return "";
    }
  };
  var fixNum = function( c ){
    switch( c ){
      case "0":
      case "O":
        return "0";
      case "1":
      case "P":
        return "1";
      case "2":
      case "Q":
        return "2";
      case "3":
      case "R":
        return "3";
      case "4":
      case "S":
        return "4";
      case "5":
      case "T":
        return "5";
      case "6":
      case "U":
        return "6";
      case "7":
      case "V":
        return "7";
      case "8":
      case "W":
        return "8";
      case "9":
      case "X":
        return "9";
      default:
        return "";
    }
  };
  var fixDot = function( c ){
    switch( c ){
      case ".":
      case "B":
      case "D":
      case "":
        return ".";
      default:
        return "";
    }
  };
  for( var i = 0; i < str.length; ++i ){
    var c = fixSign(str[i]) + fixDot(str[i]) + fixNum(str[i]);
    if( c == "" ){
      return "ERROR";
    }
    str2 += c;
  }

  /*--- l̉ ---*/
  // _ȉ
  var max_val = Slider.max_vals[Slider.current_id];
  var hoge = Math.abs( max_val / 100 );
  var sub_num = 0; // _ȉ̌
  for( var a = 1; a > hoge; a/=10 ){
    sub_num++;
  }

  var re = new RegExp("[-]?[0-9]*[\.]{0," + (sub_num>0?1:0) + "}[0-9]{0," + sub_num+ "}");
  var str3 = "" + str2.match(re);

  if( str3.length == str2.length ){
    return str2;
  }
  else{
    return "ERROR";
  }
}

// ڐ蕔NbNƂ
Slider.prototype.onclick = function(evt){
  Slider.dragging = true;
  Slider.current_id = this.id;
  document.onmousemove(evt);
  document.onmouseup();
};
// hbOJn
Slider.prototype.onmousedown = function(evt){
  Slider.dragging = true;
  Slider.current_id = this.id;
  Sim.simulate();
  Gui.updateSeatsDisplay();
  return false;
};
// hbOI
document.onmouseup = function(evt){
  if (Slider.dragging) {
    Slider.dragging = false;
    document.getElementById("slider_" + Slider.current_id + "_text").value = Slider.value;
    Slider.current_id = null;
    Sim.simulate();
    Gui.updateSeatsDisplay();
  }
};

document.onmousemove = function(evt){
  if(Slider.dragging){
    // hbOr
    if(!evt){
      evt = window.event;
    }
    var left = evt.clientX;
    var rect = document.getElementById("slider_" + Slider.current_id ).getBoundingClientRect();
    // }EXWƃXC_[̈ʒu֌WŒl߂
    var input = document.getElementById( "slider_" + Slider.current_id + "_button" );
    var width = input.clientWidth / 2;
    var val = 0;
    val = Math.round(left - rect.left - width);
    // XC_[͂ݏoƂ
    var slider = document.getElementById( "slider_" + Slider.current_id );
    if (val < 0) {
      val = 0;
    }
    else if (val > slider.clientWidth) {
      val = slider.clientWidth;
    }
    Slider.px = val;
    var min_val = Slider.min_vals[Slider.current_id];
    var max_val = Slider.max_vals[Slider.current_id];
    var hoge = Math.abs( max_val / 100 );
    var sub_num = 0;
    for( var a = 1; a > hoge; a/=10 ){
      sub_num++;
    }
    Slider.value = ( min_val + ( max_val - min_val ) * Slider.px / slider.clientWidth ).toFixed( sub_num );
    Slider.update();
    Sim.simulate();
    Gui.updateSeatsDisplay();
    return false;
  }
};

Slider.updateBar = function(){
  // ܂݂̃TCY(input.clientWidth)ʒu𒲐
  var input = document.getElementById( "slider_" + this.current_id + "_button" );
  input.style.left = (this.px - input.clientWidth/2) + 'px';
  eval( Slider.accesser[this.current_id] + "= this.value;" );
}

Slider.update = function (){
  // ܂݂̃TCY(input.clientWidth)ʒu𒲐
  var input = document.getElementById( "slider_" + this.current_id + "_button" );
  input.style.left = (this.px - input.clientWidth/2) + 'px';
  var txt = document.getElementById( "slider_" + this.current_id + "_text" );
  txt.value = this.value;
  eval( Slider.accesser[this.current_id] + "= this.value;" );
};

Slider.prototype.setMaxVal = function( max_val ){
  this.max_val = max_val;
};

Slider.prototype.setMinVal = function( min_val ){
  this.min_val = min_val;
};

Slider.prototype.setId = function( id ){
  this.id = id;
};
